<template>
  <div class="order">
    <div class="grid">
      <div class="item">
        <p class="key">تاریخ ثبت:</p>
        <p class="value">{{ order.order.created_at }}</p>
      </div>
      <div class="item" v-if="!managerMode">
        <p class="key">وضعیت:</p>
        <p class="value">{{ translateStatus(order.order.status) }}</p>
      </div>
      <Select v-else id="status" :options="statuses" v-model="status" dark class="item" label="وضعیت" no-empty/>
      <div class="item">
        <p class="key">قیمت کل:</p>
        <p class="value">{{ order.amount | formatPrice }} تومان</p>
      </div>
      <div class="item">
        <p class="key">استان:</p>
        <p class="value">{{ order.order.user_state }}</p>
      </div>
      <div class="item">
        <p class="key">شهر:</p>
        <p class="value">{{ order.order.user_city }}</p>
      </div>
      <div class="item">
        <p class="key">نام گیرنده:</p>
        <p class="value">{{ order.order.user_receiver_name }}</p>
      </div>
      <div class="item">
        <p class="key">همراه گیرنده:</p>
        <p class="value">{{ order.order.user_phone }}</p>
      </div>
      <div class="item">
        <p class="key">کد پستی:</p>
        <p class="value">{{ order.order.user_zipcode }}</p>
      </div>
      <div class="item item--address">
        <p class="key">آدرس:</p>
        <p class="value">{{ order.order.user_address }}</p>
      </div>
      <div class="item item--code">
        <p class="key">شناسه پیگیری:</p>
        <p class="value">{{order.code}}</p>
      </div>
    </div>
    <button class="button" v-ripple @click="onMoreClick" v-if="!showMore">
      <span v-if="isPending">در حال بارگذاری</span>
      <span v-else>جزئیات سفارش</span>
    </button>
    <div class="more" v-else>
      <OrderProductList :products="products" />
    </div>
  </div>
</template>

<script>
import numeral from "numeral";
import OrderProductList from "@/components/orders/OrderProductList";
import Select from "@/components/base/Select";

export default {
  name: "Order",
  components: {
    OrderProductList,
    Select
  },
  data() {
    return {
      isPending: false,
      showMore: false,
      products: [],
      statuses: [
        { id: 1, title: "در انتظار تائید" },
        { id: 2, title: "در حال آماده سازی" },
        { id: 3, title: "ارسال شده" },
        { id: 4, title: "تحویل داده شده" },
      ],
      status: { title: this.translateStatus(this.order.order.status), id: this.order.order.status }
    }
  },
  props: {
    order: {
      type: Object,
      required: true
    },
    managerMode: {
      type: Boolean,
      default: false
    }
  },
  methods:{
    onMoreClick() {
      this.products = this.order.order.products;
      this.showMore = true;
    },
    translateStatus(number) {
      switch (number) {
        case "1":
          return "در انتظار تائید";
        case "2":
          return "در حال آماده سازی";      
        case "3":
          return "ارسال شده";
        case "4":
          return "تحویل داده شده";
        default:
          return "نامشخص"
      }
    }
  },
  filters: {
    formatPrice(val) {
      return numeral(val).format("0,0");
    }
  },
  watch: {
    status() {
      const status = String(this.status.id);
      const id = this.order.id;
      const token = this.$store.getters['auth/getToken'];
      this.$store.dispatch('orders/updateStatus', {status, token, id}).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: "وضعیت سفارش با موفقیت بروزرسانی شد.",
            light: true,
            type: "success"
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: "امکان ثبت وضعیت وجود ندارد.",
            type: "error"
          });
        }
      }).catch(e => {
        if (e.response.status === 400) {
          this.$store.dispatch('notifications/push', {
            message: "امکان ثبت وضعیت وجود ندارد.",
            type: "error"
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: "خطا در بروزرسانی لطفا دوباره تلاش کنید.",
            type: "error"
          });
        }
      });
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.order
  display flex
  flex-direction column
  background-color $light-2
  color $black
  border 1px solid rgba(black, .2)
  border-radius .5rem
  overflow hidden

.button
  border none 
  padding $sm
  background-color rgba($black, .8)
  color $white
  font-family "IRANSans"
  font-size $font-size
  &:hover
    cursor pointer
    background-color rgba($black, .7)
  &:focus
    background-color rgba($black, .6)

.grid
  direction rtl
  padding $md
  display grid
  grid-template-columns repeat(4, minmax(max-content, 1fr));
  grid-gap $sm
  @media only screen and (max-width 740px)
    grid-column-gap 0
    grid-row-gap $sm

.item
  display flex
  align-items center
  &--address
    grid-column 1 / -1
  &--code
    grid-column 1 / -1
  @media only screen and (max-width 1400px)
    &:nth-child(odd)
      grid-column 1 / 3
    &:nth-child(even)
      grid-column 3 / 5
  @media only screen and (max-width 740px)
    &:nth-child(odd)
      grid-column 1 / 5
    &:nth-child(even)
      grid-column 1 / 5
  @media only screen and (max-width 600px)
    flex-direction column
    align-items flex-start
    

.key
  margin-left $sm
  @media only screen and (max-width 600px)
    margin-bottom $xsm
    margin-left none

.value
  opacity .7
</style>